unit uFrmMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Grids, Vcl.StdCtrls, uCountThread;

type
  TFrmMain = class(TForm)
    memMsg: TMemo;
    memInfo: TMemo;
    sgNums: TStringGrid;
    btnWork: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnWorkClick(Sender: TObject);
  private
    { Private declarations }

    FCountThread: TCountThread;

    // Զ TCountThread,߳أͬʱִͬԴﵽЧĿġ
    // Ƕ̵߳Ҫ
    // Ҫʾ߳(FrmMain)(ݽ)⡣

    FCurRow: integer; // ǰ Num к

    procedure DispMsg(AMsg: string);
    procedure OnThreadMsg(AMsg: string);

    procedure OnCountAction(Sender: TCountThread; ACountAction: TCountAction);

    procedure DoOnNeedANum(Sender: TCountThread);
    procedure DoOnCountResult(Sender: TCountThread);
    procedure DoOnStop(Sender: TCountThread);

  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}
{ TFrmMain }

procedure TFrmMain.btnWorkClick(Sender: TObject);
begin
  btnWork.Enabled := false; //ʼ㣬ֹ
  sgNums.Cells[2, 1] := '';
  sgNums.Cells[2, 2] := '';
  sgNums.Cells[2, 3] := '';
  FCurRow := 0;
  FCountThread.AllowedCount := true;
end;

procedure TFrmMain.DispMsg(AMsg: string);
begin
  memMsg.Lines.Add(AMsg);
end;

procedure TFrmMain.DoOnCountResult(Sender: TCountThread);
begin
  // Ƕ̴߳룬Զ VCL ķҪ
  //  Sender ϱ RowԺѹ
  TThread.Synchronize(nil,
    procedure
    begin
      sgNums.Cells[2, Sender.Row] := IntToStr(Sender.Sum);
    end);
end;

procedure TFrmMain.DoOnNeedANum(Sender: TCountThread);
var
  sNum: string;
begin

  // ̴߳룬VCL Ӧ TThread.Synchronize 
  // ˶ TCountThread, ôҪ FCurRow ,ǰʾ˵

  if FCurRow < 3 then
  begin
    inc(FCurRow);
    TThread.Synchronize(nil,
      procedure
      begin
        sNum := sgNums.Cells[1, FCurRow];
      end);
    Sender.Num := StrToInt(sNum);
    Sender.Row := FCurRow;
  end
  else
  begin
    // 3Ѽָ꣬ť ,Ƕ̴߳룬...
    TThread.Synchronize(nil,
      procedure
      begin
        btnWork.Enabled := true;
      end);
  end;
end;

procedure TFrmMain.DoOnStop(Sender: TCountThread);
begin
end;

procedure TFrmMain.FormCreate(Sender: TObject);
begin

  FCountThread := TCountThread.Create;
  FCountThread.OnMsg := self.OnThreadMsg;
  FCountThread.OnCountAction := self.OnCountAction;

  sgNums.RowCount := 4;
  sgNums.ColCount := 3;

  sgNums.Cells[0, 0] := '';
  sgNums.Cells[1, 0] := 'Num';
  sgNums.Cells[2, 0] := 'Sum';

  sgNums.Cells[0, 1] := '1';
  sgNums.Cells[0, 2] := '2';
  sgNums.Cells[0, 3] := '3';

  sgNums.Cells[1, 1] := '100';
  sgNums.Cells[1, 2] := '500';
  sgNums.Cells[1, 3] := '899';

end;

procedure TFrmMain.FormDestroy(Sender: TObject);
begin
  FCountThread.Terminate;
  FCountThread.WaitFor; // ȴ̴߳˳ execute;
  FCountThread.Free;
end;

procedure TFrmMain.OnCountAction(Sender: TCountThread; ACountAction: TCountAction);
begin
  case ACountAction of
    caNeedANum: DoOnNeedANum(Sender); // ߳һ Num
    caCountResult: DoOnCountResult(Sender); // ̷߳ؽ
    caStop: DoOnStop(Sender); // ֹ߳ͣ
  end;
end;

procedure TFrmMain.OnThreadMsg(AMsg: string);
begin
  TThread.Queue(nil,
    procedure
    begin
      DispMsg(AMsg);
    end);
end;

end.
